	-- Libraries

	local bump = require "bump"
	-- Bump

	local world = bump.newWorld(65)


function love.load()
    -- Tiles
    tile = {}

	-- Floor tiles
    for i=0,20 do -- change 3 to the number of tile images minus 1.
        tile[i] = love.graphics.newImage("assets/" .. i .. ".png" )
    end

    -- Map



	map = {}

	map.tilesize = 65

		-- Room 1 4x4

	map[#map+1] = {tile = 1, x = 200, y = 200}
	map[#map+1] = {tile = 1, x = 200+map.tilesize, y = 200}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*2, y = 200}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*3, y = 200}
	map[#map+1] = {tile = 1, x = 200, y = 200+map.tilesize}
	map[#map+1] = {tile = 1, x = 200+map.tilesize, y = 200+map.tilesize}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*2, y = 200+map.tilesize}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*3, y = 200+map.tilesize}
	map[#map+1] = {tile = 1, x = 200, y = 200+map.tilesize*2}
	map[#map+1] = {tile = 1, x = 200+map.tilesize, y = 200+map.tilesize*2}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*2, y = 200+map.tilesize*2}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*3, y = 200+map.tilesize*2}
	map[#map+1] = {tile = 1, x = 200, y = 200+map.tilesize*3}
	map[#map+1] = {tile = 1, x = 200+map.tilesize, y = 200+map.tilesize*3}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*2, y = 200+map.tilesize*3}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*3, y = 200+map.tilesize*3}

			-- Walls

				-- North

	map[#map+1] = {tile = 4, x = 200-map.tilesize, y = 200-map.tilesize}
	map[#map+1] = {tile = 8, x = 200, y = 200-map.tilesize}
	map[#map+1] = {tile = 8, x = 200+map.tilesize, y = 200-map.tilesize}
	map[#map+1] = {tile = 8, x = 200+map.tilesize*2, y = 200-map.tilesize}
	map[#map+1] = {tile = 8, x = 200+map.tilesize*3, y = 200-map.tilesize}
	map[#map+1] = {tile = 5, x = 200+map.tilesize*4, y = 200-map.tilesize}

				-- South

	map[#map+1] = {tile = 6, x = 200-map.tilesize, y = 200+map.tilesize*4}
	map[#map+1] = {tile = 10, x = 200, y = 200+map.tilesize*4}
	map[#map+1] = {tile = 10, x = 200+map.tilesize, y = 200+map.tilesize*4}
	map[#map+1] = {tile = 10, x = 200+map.tilesize*2, y = 200+map.tilesize*4}
	map[#map+1] = {tile = 10, x = 200+map.tilesize*3, y = 200+map.tilesize*4}
	map[#map+1] = {tile = 7, x = 200+map.tilesize*4, y = 200+map.tilesize*4}

				-- West

	map[#map+1] = {tile = 9, x = 200-map.tilesize, y = 200}
	map[#map+1] = {tile = 9, x = 200-map.tilesize, y = 200+map.tilesize*1}
	map[#map+1] = {tile = 9, x = 200-map.tilesize, y = 200+map.tilesize*2}
	map[#map+1] = {tile = 9, x = 200-map.tilesize, y = 200+map.tilesize*3}
	map[#map+1] = {tile = 6, x = 200-map.tilesize, y = 200+map.tilesize*4}

				-- East

	map[#map+1] = {tile = 15, x = 200+map.tilesize*4, y = 200}
	map[#map+1] = {tile = 3, x = 200+map.tilesize*4, y = 200+map.tilesize*1}
	map[#map+1] = {tile = 14, x = 200+map.tilesize*4, y = 200+map.tilesize*2}
	map[#map+1] = {tile = 11, x = 200+map.tilesize*4, y = 200+map.tilesize*3}
	map[#map+1] = {tile = 7, x = 200+map.tilesize*4, y = 200+map.tilesize*4}

		-- Corridor 1 x 4

	map[#map+1] = {tile = 1, x = 200+map.tilesize*5, y = 200+map.tilesize*1}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*6, y = 200+map.tilesize*1}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*7, y = 200+map.tilesize*1}
	map[#map+1] = {tile = 1, x = 200+map.tilesize*8, y = 200+map.tilesize*1}
	map[#map+1] = {tile = 3, x = 200+map.tilesize*9, y = 200+map.tilesize*1}

			-- Walls

				-- North

				map[#map+1] = {tile = 8, x = 200+map.tilesize*5, y = 200}
				map[#map+1] = {tile = 8, x = 200+map.tilesize*6, y = 200}
				map[#map+1] = {tile = 8, x = 200+map.tilesize*7, y = 200}
				map[#map+1] = {tile = 8, x = 200+map.tilesize*8, y = 200}
				map[#map+1] = {tile = 12, x = 200+map.tilesize*9, y = 200}

				-- South

				map[#map+1] = {tile = 10, x = 200+map.tilesize*5, y = 200+map.tilesize*2}
				map[#map+1] = {tile = 10, x = 200+map.tilesize*6, y = 200+map.tilesize*2}
				map[#map+1] = {tile = 10, x = 200+map.tilesize*7, y = 200+map.tilesize*2}
				map[#map+1] = {tile = 10, x = 200+map.tilesize*8, y = 200+map.tilesize*2}
				map[#map+1] = {tile = 13, x = 200+map.tilesize*9, y = 200+map.tilesize*2}


	function CorridorNorth(a,b,length, broadness, t)

		for i = 1, length do


		t[#t+1] = {tile = 9, x = a,y=b+t.tilesize*i}

			for j = 1, broadness do

			t[#t+1] = {tile = 1, x = a+t.tilesize*j,y=b+t.tilesize*i}

			end

		t[#t+1] = {tile = 11, x = a+t.tilesize*broadness+t.tilesize,y=b+t.tilesize*i}

		end

		return t

	end

	function CorridorSouth(a,b,length, broadness, t)

		for i = 1, length do


		t[#t+1] = {tile = 9, x = a,y=b-t.tilesize*i}

			for j = 1, broadness do

			t[#t+1] = {tile = 1, x = a-t.tilesize*j,y=b-t.tilesize*i}

			end

		t[#t+1] = {tile = 11, x = a-t.tilesize*broadness-t.tilesize,y=b-t.tilesize*i}

		end

		return t

	end

	function CorridorWest(a,b,length,broadness,t)

		for i = 1, length do


		t[#t+1] = {tile = 8, y = a,x=b-t.tilesize*i}

			for j = 1, broadness do

			t[#t+1] = {tile = 1, y = a-t.tilesize*j,x=b-t.tilesize*i}

			end

		t[#t+1] = {tile = 10, y = a-t.tilesize*broadness-t.tilesize,x=b-t.tilesize*i}

		end

		return t

	end

	function CorridorEast(a,b,length,broadness,t)

		for i = 1, length do


		t[#t+1] = {tile = 8, y = a,x=b+t.tilesize*i}

			for j = 1, broadness do

			t[#t+1] = {tile = 1, y = a+t.tilesize*j,x=b+t.tilesize*i}

			end

		t[#t+1] = {tile = 10, y = a+t.tilesize*broadness+t.tilesize,x=b+t.tilesize*i}

		end

		return t

	end

	function Room(a,b,length,broadness,t)

		t[#t+1] = {tile = 4, x = a, y=b}

		for i = 1, length do
			if i == 1 then
			t[#t+1] = {tile = 4, x = a+t.tilesize*i, y=b}
			end

		end

		return t

	end

	-- Player variables

	player = {
		x = 200,
		y = 200,
		w = nil,
		h = nil,
		speed = 200,
		rotSpeed = 4,
		velocity = 0,
		angle = 0,
		img_still = nil,
		img_walk = nil}

	-- Player images
	player.img_still = love.graphics.newImage("assets/player_still.png")

	player.w = player.img_still:getWidth()
	player.h = player.img_still:getHeight()

	world:add(player.img_still, player.x,player.y,player.w,player.h)

	for i,v in ipairs(map) do

		if v.tile ~= 1 then
		world:add("tile" .. i, v.x,v.y,map.tilesize,map.tilesize)
		end

	end

end




function drawMap()

	for i,v in ipairs(map) do

	love.graphics.draw(tile[v.tile], v.x, v.y)

	end

end


function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function love.update( dt )
	player.velocity = 0

	-- Variable update

	map_x = player.x
	map_y = player.y

   -- Player input

	if love.keyboard.isDown("w") then
	player.velocity = player.speed
	elseif love.keyboard.isDown("s") then
	player.velocity = -player.speed
	end

	if love.keyboard.isDown("d") then
		player.angle = player.angle + player.rotSpeed * dt
		if player.angle > math.pi*2 then
		player.angle = 0
		end
	elseif love.keyboard.isDown("a") then
		player.angle = player.angle - player.rotSpeed * dt
		if player.angle < 0 then
		player.angle = math.pi*2
		end
	end

	-- Movement update
	player.x = player.x + math.cos(player.angle) * player.velocity * dt
	player.y = player.y + math.sin(player.angle) * player.velocity * dt

    if love.keyboard.isDown( "escape" ) then
        love.event.quit()
    end

	-- Bump

	world:update(player.img_still, player.x,player.y,player.w, player.h)
	for i,v in ipairs(map) do
		if v.tile ~= 1 then
		world:update("tile"..i, v.x,v.y,65,65)
		end
	end

	local actualX,
	actualY,
	cols,
	len = world:move(player.img_still, math.cos(player.angle) * player.velocity * dt, player.y + math.sin(player.angle) * player.velocity * dt)


end

function love.draw()
love.graphics.translate(-player.x + 400, -player.y + 300)
drawMap()
love.graphics.draw(player.img_still, player.x, player.y, player.angle,1,1,player.w/2,player.h/2)


end
